<?php
/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Controllers\Administrator;

use App\Exceptions\DefaultException;
use App\Http\Base\BaseController;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\Http\Services\PermintaanbarangService;
use App\Http\Services\UsersService;
use App\Http\Validators\PermintaanbarangValidator;
use App\Http\Services\ItemService;
use App\Http\Services\WorkflowService;
use App\Http\Services\LokasiitemService;
// use App\Http\Services\makananervice;
// use App\Http\Services\UsersService;
use App\Http\Services\ItempermintaanbarangService;
use App\Http\Services\VoyagesService;
use App\Http\Services\ActivitylogService;
use PDF;
//use App\Http\Handler\PdfHandler;

class PermintaanbarangController extends BaseController
{
    protected $baseService;
    protected $validator;
    // private $kapal;
    private $lokasiitem;
    private $itempermintaanbarang;
    private $workflow;
    private $voyage;
    private $item;
    private $users;
    private $activityLog;

    /**
     * Permintaanbarang constructor.
     */
    public function __construct()
    {
        parent::__construct();
        $this->baseService = new PermintaanbarangService();
        $this->validator = new PermintaanbarangValidator();
        // $this->kapal = new KapalService();
        $this->workflow = new WorkflowService();
        $this->lokasiitem = new LokasiitemService();
        $this->item = new ItemService();
        $this->users = new UsersService();
        $this->voyage = new VoyagesService();
        $this->itempermintaanbarang = new ItempermintaanbarangService();
        $this->activityLog = new ActivitylogService();
    }


    /**
     * @param Request $request
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function store(Request $request)
    {
        $input = $request->all();
        $this->validator->beforeInsert($input);
        if ($this->validator->hasError()) {
            return $this->validator->validateView();
        }
        DB::beginTransaction();
        try {
            $auth = json_decode($request->session()->get('auth'));

            // $input["refId"] = $input["prNumber"] = $this->baseService->getLastestID("PELNI/" . $input["tipeTransaksi"] . " " . date("y") . " " . $input["kodeKapal"]);   
            $input["refId"] = $input["prNumber"] = $this->baseService->getLastestID($input["tipeTransaksi"] . date("y") . $auth->orgId);
            $ID = $this->baseService->store($input);
            $this->itempermintaanbarang->store($input);
            $this->workflow->store($input);

            $input["date"] = date("Y-m-d H:i:s");
            $input["username"] = $auth->username;
            $input["activity"] = "CREATE";
            $input["deskripsi"] = $auth->name . " just <b>created</b> new Permintaan Barang <a href=\"" . url("administrator/permintaanbarang/" . $ID) . "\">" . $input["refId"] . "</a>";
            $this->activityLog->store($input);

            DB::commit();
            $this->sync();
            return redirect()->to("administrator/permintaanbarang")->with("successMessages", "Data sudah berhasil dibuat dengan No #" . $input["refId"]);
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @param Request $request
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function paging(Request $request)
    {
        $input = $request->all();
        $this->data["header"] = [
            "prNumber" => "PR Number", "kapalId" => "Kapal", "locationId" => "Location", "approverId" => "Approver", "requesterId" => "Requester", "destinationType" => "Destination Type"
        ];
        $this->data["criteria"] = [
            "prNumber" => "PR Number", "kapalId" => "Kapal", "locationId" => "Location", "approverId" => "Approver", "requesterId" => "Requester", "destinationType" => "Destination Type"
        ];
        $this->data["ordering"] = [
            "prNumber:asc" => "PR Number &uarr;", "prNumber:desc" => "PR Number &darr;", "tglPermintaan:asc" => "Tgl Permintaan &uarr;", "tglPermintaan:desc" => "Tgl Permintaan &darr;", "voyageKode:asc" => "Voyage &uarr;", "voyageKode:desc" => "Voyage &darr;"
        ];

        $this->data["voyages"] = $this->voyage->getVoyages($request);
        $this->data["permintaanbarangs"] = $this->baseService->paging($request);
        return view("modules.permintaanbarang.permintaanbarang_index", $this->data);
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function edit($id)
    {
        $this->data["permintaanbarang"] = $this->baseService->show($id);

        $this->data["criteria"] = [
            "permintaanbarang.id" => "ID",
            "namaItem" => "Nama Item", "deskripsi" => "Deskripsi"
        ];

        $this->data["listItems"] = $this->itempermintaanbarang->showBasedOnPermintaanbarang($id);

        return view("modules.permintaanbarang.permintaanbarang_edit", $this->data);
    }


    /**
     * @param Request $request
     * @param $id
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function update(Request $request, $id)
    {
        $this->validator->beforeUpdate($request->all(), $id);
        if ($this->validator->hasError())
            return $this->validator->validateView();
        DB::beginTransaction();
        try {
            $this->baseService->update($id, $request->all());
            DB::commit();
            $this->sync();
            return redirect()->to("administrator/permintaanbarang")->with("successMessages", "Data has been updated");
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function create(Request $request)
    {
        $this->data["lokasiitems"] = $this->lokasiitem->index($request);

        $this->data["criteria"] = [
            "deskripsi"     => "Deskripsi",
            "part_number"   => "Part Number",
            "namaItem"      => "Kode Item"
        ];
        $today = date('Y-m-d');
        $auth = json_decode($request->session()->get('auth'));
        $this->data["portBunker"] = explode(";", $auth->sysParams->PORTBUNKER);
        $this->data["voyages"] = $this->voyage->getVoyageByDate($request, $today);
        return view("modules.permintaanbarang.permintaanbarang_create", $this->data);
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function show(Request $request, $id)
    {
        $this->data["permintaanbarang"] = $this->baseService->show($id);
        if ($this->data["permintaanbarang"]) {
            $auth = json_decode($request->session()->get('auth'));
            $this->data["portBunker"] = explode(";", $auth->sysParams->PORTBUNKER);
            $this->data["listItems"] = $this->itempermintaanbarang->showBasedOnPermintaanbarang($request, $this->data["permintaanbarang"]);
            $this->data["isApproval"] = false;
            return view("modules.permintaanbarang.permintaanbarang_show", $this->data);
        } else {
            return redirect()->back()->with("errMessage", "No data found. Please check this with your Administrator/Nahkoda.");
        }
    }

    /**
     *  index function that get all data from database by default
     * @param $ids
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function destroy($ids)
    {
        $this->baseService->delete($ids);
        return redirect()->back()->with("successMessages", "Data has been deleted");
    }

    public function approval(Request $request, $id)
    {
        $this->data["permintaanbarang"] = $this->baseService->show($id);
        if ($this->data["permintaanbarang"]) {
            $auth = json_decode($request->session()->get('auth'));
            $this->data["portBunker"] = explode(";", $auth->sysParams->PORTBUNKER);
            $this->data["listItems"] = $this->itempermintaanbarang->showBasedOnPermintaanbarang($request, $this->data["permintaanbarang"]);
            $this->data["isApproval"] = true;
            return view("modules.permintaanbarang.permintaanbarang_show", $this->data);
        } else {
            return redirect()->to("administrator/workflow")->with("errMessage", "Sorry! Data can't be found.");
        }
    }

    public function saveApproval(Request $request)
    {
        $auth = json_decode($request->session()->get('auth'));
        $input = $request->all();
        $input["isApproved"] = $input["status"];
        $input["refId"] = $input["prNumber"];
        $this->validator->beforeApprove($input);
        if ($this->validator->hasError()) {
            return $this->validator->validateView();
        }

        $transaction = $this->baseService->showByTransactionNo($input["refId"]);
        if ($transaction->isApproved > 0) {
            return redirect()->back()->with("errMessage", "Status transaksi #" . $input["refId"] . " sudah tidak open lagi!");
        } else {

            DB::beginTransaction();
            try {
                $this->baseService->approve($input);
                $this->workflow->approve($input);

                if ($input["status"] == 1) {
                    $staging["header"] = $transaction; // $this->baseService->showByTransactionNo($input["prNumber"]);
                    $staging["footer"] = $this->itempermintaanbarang->showBasedOnPermintaanbarang($request, $staging["header"]);
                    $staging["auth"] = $auth;
                    $this->baseService->saveStaging($staging);
                }

                $input["date"] = date("Y-m-d H:i:s");
                $input["username"] = $auth->username;
                $input["activity"] = "APPROVAL";
                $input["namaTransaksi"] = "Workflow";
                $input["deskripsi"] = $auth->name . " just <b>approved</b> transaction Permintaan Barang <b>#" . $input["refId"] . "</b>";
                $this->activityLog->store($input);

                DB::commit();
                $this->sync();
                return redirect()->to("administrator/workflow")->with("successMessages", "Data dengan No #" . $input["refId"] . " sudah berhasil disimpan");
            } catch (\Exception $e) {
                DB::rollBack();
                throw new DefaultException($e->getMessage());
            }
        }   // end of file IF
    }

    public function search(Request $request)
    {
        $data = $this->item->pagingModal($request);
        echo json_encode($data);
    }

    public function getVoyages(Request $request)
    {
        $input = $request->all();
        if (!empty($input["tglValidasi"])) {
            $data = $this->voyage->getVoyageByDate($request, $input["tglValidasi"]);
            if ($data) {
                echo json_encode($data);
            } else {
                echo json_encode(null);
            }
        } else {
            echo json_encode(null);
        }
    }

    public function getFutureVoyages(Request $request)
    {
        $input = $request->all();
        if (!empty($input["tglValidasi"])) {
            $data = $this->voyage->getFutureVoyageByDate($request, $input["tglValidasi"]);
            if ($data) {
                echo json_encode($data);
            } else {
                echo json_encode(null);
            }
        } else {
            echo json_encode(null);
        }
    }

    public function getVoyagesByDateRange(Request $request)
    {
        $input = $request->all();
        if (!empty($input["dateStart"]) && !empty($input["dateEnd"])) {
            $data = $this->voyage->getVoyagesByDateRange($request);
            echo json_encode($data);
        } else {
            echo json_encode(null);
        }
    }

    public function getVoyageDate(Request $request)
    {
        $input = $request->all();
        $data = $this->voyage->show($input["voyageKode"], "voyageKode", "LIKE");
        if ($data) {
            if ($data && $data->voyage_from) {
                $data->voyage_from = date("Y-m-d", strtotime($data->voyage_from));
            }
            if ($data && $data->voyage_to) {
                $data->voyage_to = date("Y-m-d", strtotime($data->voyage_to));
            }
            echo json_encode($data);
        } else {
            echo json_encode(null);
        }
    }

    public function generateSPB(Request $request, $ID)
    {
        $auth = json_decode($request->session()->get('auth'));

        PDF::SetTitle('Permintaan Barang');
        PDF::AddPage();

        $conditions = [
            ["field" => "type_id", "operator" => "!=", "value" => $auth->sysParams->PELNIFNB],
            ["field" => "type_id", "operator" => "!=", "value" => $auth->sysParams->PELNIMEAL]
        ];

        $data['totalPageCount'] = PDF::getAliasNbPages();
        $data["permintaanbarang"] = $this->baseService->show($ID);
        $data["listItems"] = $this->itempermintaanbarang->showBasedOnPermintaanbarang($request, $data["permintaanbarang"], $conditions);

        $data["requester"] = $this->users->show($data["permintaanbarang"]->requesterId);
        $data["approver"] = $data["requester"];
        if ($data["permintaanbarang"]->isApproved > 0 && $data["permintaanbarang"]->approverId) {
            if ($data["permintaanbarang"]->requesterId == $data["permintaanbarang"]->approverId) {
                $data["approver"] = $data["requester"];
            } else {
                $approver = $this->users->show($data["permintaanbarang"]->approverId);
                if ($approver) {
                    $data["approver"] = $approver;
                }
            }
        } else {
            $approver = $this->users->getNahkodaProfile($data["permintaanbarang"]->kapalId, $auth->sysParams->JABATANNAHKODA);
            if ($approver) {
                $data["approver"] = $approver;
            }
        }

        // return view("modules.permintaanbarang.spb", $data);

        $view = \View::make("modules.permintaanbarang.spb", $data);
        $htmlContent = $view->render();
        PDF::writeHTML($htmlContent, true, false, true, false . "");
        PDF::Output('permintaanbarang-barang.pdf');
    }

    public function generateSPBPost(Request $request)
    {
        $auth = json_decode($request->session()->get('auth'));
        $input = $request->all();
        $ID = $input["transactionID"];

        PDF::SetTitle('Permintaan Barang');
        PDF::AddPage();

        $conditions = [
            ["field" => "type_id", "operator" => "!=", "value" => $auth->sysParams->PELNIFNB],
            ["field" => "type_id", "operator" => "!=", "value" => $auth->sysParams->PELNIMEAL]
        ];

        $data["rev"] = $input["rev"];
        $data["bagian"] = $input["bagian"];
        $data["kode"] = $input["kode"];
        $data['totalPageCount'] = PDF::getAliasNbPages();
        $data["permintaanbarang"] = $this->baseService->show($ID);
        $data["listItems"] = $this->itempermintaanbarang->showBasedOnPermintaanbarang($request, $data["permintaanbarang"], $conditions);

        $data["requester"] = $this->users->show($data["permintaanbarang"]->requesterId);
        $data["approver"] = $data["requester"];
        if ($data["permintaanbarang"]->isApproved > 0 && $data["permintaanbarang"]->approverId) {
            if ($data["permintaanbarang"]->requesterId == $data["permintaanbarang"]->approverId) {
                $data["approver"] = $data["requester"];
            } else {
                $approver = $this->users->show($data["permintaanbarang"]->approverId);
                if ($approver) {
                    $data["approver"] = $approver;
                }
            }
        } else {
            $approver = $this->users->getNahkodaProfile($data["permintaanbarang"]->kapalId, $auth->sysParams->JABATANNAHKODA);
            if ($approver) {
                $data["approver"] = $approver;
            }
        }

        // return view("modules.permintaanbarang.spb", $data);

        $view = \View::make("modules.permintaanbarang.spb", $data);
        $htmlContent = $view->render();
        PDF::writeHTML($htmlContent, true, false, true, false . "");
        PDF::Output('permintaanbarang-barang.pdf');
    }

    public function foodPDF(Request $request, $ID)
    {

        $auth = json_decode($request->session()->get('auth'));

        PDF::SetTitle('Permintaan Bahan Makanan');
        PDF::AddPage();

        $conditions = [
            ["field" => "type_id", "operator" => "=", "value" => $auth->sysParams->PELNIFNB]
        ];

        $data['totalPageCount'] = PDF::getAliasNbPages();
        $data["permintaanbarang"] = $this->baseService->show($ID);
        $data["listItems"] = $this->itempermintaanbarang->showBasedOnPermintaanbarang($request, $data["permintaanbarang"], $conditions);

        $data["requester"] = $this->users->show($data["permintaanbarang"]->requesterId);
        if ($data["permintaanbarang"]->isApproved > 0 && $data["permintaanbarang"]->approverId > 0) {
            if ($data["permintaanbarang"]->requesterId == $data["permintaanbarang"]->approverId) {
                $data["approver"] = $data["requester"];
            } else {
                $approver = $this->users->show($data["permintaanbarang"]->approverId);
                if ($approver) {
                    $data["approver"] = $approver;
                }
            }
        } else {
            $approver = $this->users->getNahkodaProfile($data["permintaanbarang"]->kapalId, $auth->sysParams->JABATANNAHKODA);
            if ($approver) {
                $data["approver"] = $approver;
            } else {
                $data["approver"] = $data["requester"];
            }
        }

        $view = \View::make("modules.permintaanbarang.spb-food", $data);
        $htmlContent = $view->render();
        PDF::writeHTML($htmlContent, true, false, true, false . "");
        PDF::Output('permintaanbarang-makanan.pdf');
    }

    public function foodPDFPost(Request $request)
    {
        $input = $request->all();
        $ID = $input["transactionID"];
        $auth = json_decode($request->session()->get('auth'));

        $data["jlhOrang"] = $input["jlhOrang"];
        $data["tglSupply"] = $input["tglSupply"];
        $data["namaPelabuhan"] = $input["namaPelabuhan"];
        $data["rev"] = $input["rev"];

        PDF::SetTitle('Permintaan Bahan Makanan');
        PDF::AddPage();

        $conditions = [
            ["field" => "type_id", "operator" => "=", "value" => $auth->sysParams->PELNIFNB]
        ];

        $data['totalPageCount'] = PDF::getAliasNbPages();
        $data["permintaanbarang"] = $this->baseService->show($ID);
        $data["listItems"] = $this->itempermintaanbarang->showBasedOnPermintaanbarang($request, $data["permintaanbarang"], $conditions);

        $data["requester"] = $this->users->show($data["permintaanbarang"]->requesterId);
        if ($data["permintaanbarang"]->isApproved > 0 && $data["permintaanbarang"]->approverId > 0) {
            if ($data["permintaanbarang"]->requesterId == $data["permintaanbarang"]->approverId) {
                $data["approver"] = $data["requester"];
            } else {
                $approver = $this->users->show($data["permintaanbarang"]->approverId);
                if ($approver) {
                    $data["approver"] = $approver;
                }
            }
        } else {
            $approver = $this->users->getNahkodaProfile($data["permintaanbarang"]->kapalId, $auth->sysParams->JABATANNAHKODA);
            if ($approver) {
                $data["approver"] = $approver;
            } else {
                $data["approver"] = $data["requester"];
            }
        }

        $view = \View::make("modules.permintaanbarang.spb-food", $data);
        $htmlContent = $view->render();
        PDF::writeHTML($htmlContent, true, false, true, false . "");
        PDF::Output('permintaanbarang-makanan.pdf');
    }

    public function generateBBM(Request $request)
    {
        $input = $request->all();
        $auth = json_decode($request->session()->get('auth'));

        $ID = $input["transactionID"];
        $data["nomor"] = $input["nomor"];

        PDF::SetTitle('PERMINTAAN  BBM &amp; MINYAK PELUMAS');
        PDF::AddPage();

        $conditions = [
            ["field" => "type_id", "operator" => "whereIn", "value" => explode(";", $auth->sysParams->PELNIBBMPELUMAS)]
        ];

        $data['totalPageCount'] = PDF::getAliasNbPages();
        $data["permintaanbarang"] = $this->baseService->show($ID);
        $data["listItems"] = $this->itempermintaanbarang->showBasedOnPermintaanbarang($request, $data["permintaanbarang"], $conditions);


        //        $dateReport = $input["monthYear"];
        //        $dateStart  =  date("Y-m-01", strtotime( $input["monthYear"]));
        //        $dateEnd  = date("Y-m-t", strtotime($dateStart));
        //        $kapalId  = $input["kapalId"];

        $data["requester"] = $this->users->show($data["permintaanbarang"]->requesterId);
        if ($data["permintaanbarang"]->isApproved > 0 && $data["permintaanbarang"]->approverId > 0) {
            if ($data["permintaanbarang"]->requesterId == $data["permintaanbarang"]->approverId) {
                $data["approver"] = $data["requester"];
            } else {
                $approver = $this->users->show($data["permintaanbarang"]->approverId);
                if ($approver) {
                    $data["approver"] = $approver;
                }
            }
        } else {
            $approver = $this->users->getNahkodaProfile($data["permintaanbarang"]->kapalId, $auth->sysParams->JABATANNAHKODA);
            if ($approver) {
                $data["approver"] = $approver;
            } else {
                $data["approver"] = $data["requester"];
            }
        }

        $view = \View::make("modules.permintaanbarang.bbmminyak_pdf", $data);
        $htmlContent = $view->render();
        PDF::writeHTML($htmlContent, true, false, true, false . "");
	PDF::Output('permintaanbarang-bbm-pelumas.pdf');
    }
}
